import 'dart:collection';

import 'package:_private_core/_private_core.dart';
import 'package:_private_core/theme/option_network.dart';
import 'package:dio/dio.dart';


Map<String, dynamic> appMapParms([Map? value]) {
  Map<String, dynamic> params = {};
  if (value != null && value.isNotEmpty) {
    params.addAll(HashMap.from(value));
  }
  params
    ..removeWhere((key, value) => value == null)
    // ..addAll({
    //   'platformId': valuePlatformByConfig(),
    //   'languageCode': appPrefs.languageCode,
    // })
    ;
  return params;
}

PNetworkOptionsImpl get networkOptions =>
    coreConfig.coreOptions.networkOptions as PNetworkOptionsImpl;

String get appBaseUrl => networkOptions.baseUrl;
String get appBaseUrlAsset => networkOptions.baseUrlAsset;
String? get appBaseUrlGeotracking => networkOptions.baseUrlGeotracking;
String? get appMqttUrl => networkOptions.mqttUrl;
int? get appMqttPort => networkOptions.mqttPort;
Function(DioError)? get errorInterceptor => networkOptions.errorInterceptor;

class PNetworkOptionsImpl extends PNetworkOptions {
  final Function(DioError)? errorInterceptor;

  @override
  String appImageCorrectUrl(String url, {base}) {
    if (url.trim().indexOf('http') != 0) {
      if ((base ?? baseUrlAsset ?? '').endsWith('/') && url.startsWith('/')) {
        return (base ?? baseUrlAsset ?? '') + url.substring(1);
      }
      return (base ?? baseUrlAsset ?? '') + url;
    }
    return url;
  }

  PNetworkOptionsImpl({
    required super.baseUrl,
    required super.baseUrlAsset,
    super.baseUrlGeotracking,
    super.mqttUrl,
    super.mqttPort,
    this.errorInterceptor,
  });
}
